import pygame
import math
class player:
    def __init__(self,x,y,image):
        self.x = x
        self.y = y
        self.image = image
        self.speed = 100
        self.rotation = 0
        self.bullet_list = []
        self.shotTimer = 0.5
        self.radius = 55
        self.power_timer = 5
        self.score = 0
        self.state = "normal"
        self.sight_rad = 200
        self.health = 10
        self.invincibility_timer = 5
    def update(self,dt,enemy):
        self.dt = dt
        if self.invincibility_timer > 0:
            self.invincibility_timer -= dt
        if self.state != "normal":
            self.power_timer -= dt
        if self.power_timer <= 0:
            self.power_timer += 5
            if self.state == "Speed":
                self.speed /= 2
            self.state = "normal"

        if self.shotTimer > 0:
            self.shotTimer -= self.dt

        distance = (abs((enemy.enemyX - self.x)) ** 2 + abs((enemy.enemyY - self.y)) ** 2) ** 0.5

        if distance < enemy.rad + self.radius:
            #OUCH
            if self.invincibility_timer <= 0:
                ouch = pygame.mixer.Sound("player_hurt.wav")
                self.health -= 1
                print(self.health)
                pygame.mixer.Sound.play(ouch)
                pygame.mixer.music.stop()
                self.invincibility_timer = 5

        for b in self.bullet_list:
            distance = (abs((enemy.enemyX - b.x)) ** 2 + abs((enemy.enemyY - b.y)) ** 2) ** 0.5
            if distance < enemy.rad + 5:
                self.bullet_list.remove(b)
                return True

        for b in self.bullet_list:
            b.update(dt)

        if self.x > 1499:
           self.x = 1499
        if self.x < 0:
            self.x = 0
        if self.y > 699:
            self.y = 699
        if self.y < 0:
            self.y = 0


    def powerup(self,state):
        speedUp = pygame.mixer.Sound("speed_pickup.wav")
        invUp = pygame.mixer.Sound("inv_pickup.wav")
        if state == "Speed":
            if self.state == "normal":
                pygame.mixer.Sound.play(speedUp)
                pygame.mixer.music.stop()
                self.speed *= 2
                self.state = "Speed"
        if state == "Inv":
            if self.state == "normal":
                pygame.mixer.Sound.play(invUp)
                pygame.mixer.music.stop()
                self.state == "Inv"
                self.invincibility_timer += 5

        if state == "astronaut":
            foundEm = pygame.mixer.Sound("rescue.wav")
            pygame.mixer.Sound.play(foundEm)
            pygame.mixer.music.stop()
            self.score += 1

    def input(self,event,keys):
        playerShot = pygame.mixer.Sound("Player_shot.wav")
        if keys[pygame.K_w]:
            self.y -= self.speed * self.dt
        if keys[pygame.K_a]:
            self.x -= self.speed * self.dt
        if keys[pygame.K_s]:
            self.y += self.speed * self.dt
        if keys[pygame.K_d]:
            self.x += self.speed * self.dt
        mouse_x, mouse_y = pygame.mouse.get_pos()
        mouseButtons = pygame.mouse.get_pressed()
        adj = mouse_x - self.x
        opp = mouse_y - self.y
        self.rotation = math.atan2(opp,adj)
        imgrot = math.atan2(-opp,adj)
        deg = math.degrees(imgrot)
        self.rotImg = pygame.transform.rotate(self.image, deg-90)

        #Check for the bullet timer and if that is true and the space bar is pressed shoot a bullet
        if mouseButtons[0]:
            if self.shotTimer <= 0:
                print(self.shotTimer)
                pygame.mixer.Sound.play(playerShot)
                pygame.mixer.music.stop()

                bullet_x_speed = 200*math.cos(self.rotation)
                bullet_y_speed = 200*math.sin(self.rotation)
                new_bullet = Bullet(self.x+ bullet_x_speed / 2.5,self.y + bullet_y_speed/2.5,bullet_x_speed,bullet_y_speed)
                self.bullet_list.append(new_bullet)
                self.shotTimer += 0.5

                #Sound for shooting?




    def draw(self,surf):

        surf.blit(self.rotImg, (self.x - self.rotImg.get_width() / 2, self.y - self.rotImg.get_height() / 2))
        #pygame.draw.circle(surf,(255,0,0),(int(self.x),int(self.y)),self.radius,1)
        pygame.draw.circle(surf, (255, 0, 0), (int(self.x), int(self.y)), self.sight_rad, 1)
        for b in self.bullet_list:
            b.draw(surf)
        font = pygame.font.SysFont("Times new roman", 30, True)
        text = font.render("Health: " + str(self.health), 1, (255,255,255))
        surf.blit(text, (0, 665))
        font = pygame.font.SysFont("Times new roman", 30, True)
        text = font.render("Score: " + str(self.score), 1, (255,255,255))
        surf.blit(text, (150, 665))
    def gotHit(self,State):
        if State == True:

            self.health -= 1
            print(self.health)
            self.invincibility_timer += 5
class Bullet:
    def __init__(self,x,y,x_speed,y_speed):
        self.x = x
        self.y = y
        self.x_speed = x_speed
        self.y_speed = y_speed
    def update(self,dt):
        self.x += self.x_speed * dt
        self.y += self.y_speed * dt

    def draw(self, surf):

        pygame.draw.circle(surf,(0,255,0),(int(self.x),int(self.y)),5)