import pygame
import random
import Player
import collectible
import newenemy

class Level_Manager:
    def __init__(self,img_list,win):
        self.level = 0
        randX = random.randint(100, 1600)
        randY = random.randint(100, 600)
        self.e = newenemy.enemy(randX, randY, img_list["enemy"])
        self.p = Player.player(400,300,img_list["ship"])
        self.target_list = []
        self.power_list = []
        self.pickup_timer = 0
        self.img_list = img_list
        self.win = win
        self.enemyHit = False
    def update(self,dt):
        self.enemyHit = False
        if self.pickup_timer > 0:
            self.pickup_timer -= dt
        else:
            px = random.randint(10, self.win.get_width())
            py = random.randint(10, self.win.get_height())
            powerType = random.randint(0,1)
            if powerType == 0:
                new_power = collectible.collectible(px, py, self.img_list["speed_pickup"], "Speed")
            else:
                new_power = collectible.collectible(px, py, self.img_list["inv_pickup"], "Inv")
            self.power_list.append(new_power)
            self.pickup_timer += 10
        for p in self.power_list:
            p.update()

            state = p.collect(self.p.x,self.p.y,self.p.radius)

            if state is not None:
                self.p.powerup(state)
                self.power_list.remove(p)




        hitState = False
        if self.p.update(dt,self.e):
            playerHit = pygame.mixer.Sound("player_hurt.wav")
            pygame.mixer.Sound.play(playerHit)
            pygame.mixer.music.stop()
            hitState = True

        if self.e.update(dt, self.p.x, self.p.y, self.p.radius,hitState):
            enemyGotHit = pygame.mixer.Sound("Enemy_hurt.wav")
            pygame.mixer.Sound.play(enemyGotHit)
            pygame.mixer.music.stop()
            self.enemyHit = True

        self.p.gotHit(self.enemyHit)

        for t in self.target_list:
            t.update()
            state = t.collect(self.p.x,self.p.y,self.p.radius)

            if state is not None:
                self.p.powerup(state)
                self.target_list.remove(t)

        if len(self.target_list) == 0:
            self.level += 1
            i = 0
            while i != self.level:
                x = random.randint(10, self.win.get_width())
                y = random.randint(10, self.win.get_height())
                new_target = collectible.collectible(x,y,self.img_list["astronaut"],"astronaut")
                self.target_list.append(new_target)
                i += 1



    def input(self,event,keys):
        self.p.input(event,keys)
        pass
    def draw(self,surf):
        self.p.draw(surf)
        self.e.draw(surf)
        font = pygame.font.SysFont("Times new roman", 30, True)
        text = font.render("Level: " + str(self.level), 1, (255,255,255))
        surf.blit(text, (0, 0))


        for t in self.target_list:
            state = t.collect(self.p.x,self.p.y,self.p.sight_rad)

            if state is not None:
                t.draw(surf)
        for p in self.power_list:
            p.draw(surf)
