import pygame
import math
import random
class enemy:
    def __init__(self,enemyX,enemyY,image):
        self.enemyX = enemyX
        self.enemyY = enemyY
        self.image = image
        self.speed = 100
        self.rotation = 0
        self.enemy_bullet_list = []
        self.shotTimer = 0.5
        self.rad = 55
        self.health = 10

    def update(self,dt, playerX, playerY, playerRad,hitState):
        self.dt = dt
        if hitState == True:
            self.health -= 1
            if self.health == 0:
                enemyDisable = pygame.mixer.Sound("Explosion.wav")
                pygame.mixer.Sound.play(enemyDisable)
                pygame.mixer.music.stop()
                self.shotTimer += 15
        if self.shotTimer > 0:
            self.shotTimer -= self.dt

        for b in self.enemy_bullet_list:
            distance = (abs((playerX - b.x)) ** 2 + abs((playerY - b.y)) ** 2) ** 0.5
            if distance < 5 + playerRad:
                self.enemy_bullet_list.remove(b)
                return True

        for b in self.enemy_bullet_list:
            b.update(dt)

        enemyShot = pygame.mixer.Sound("enemy_shot.wav")
        adj = playerX - self.enemyX
        opp = playerY - self.enemyY
        self.rotation = math.atan2(opp,adj)
        imgrot = math.atan2(-opp,adj)
        deg = math.degrees(imgrot)
        self.rotImg = pygame.transform.rotate(self.image, deg-90)

        #Check for the bullet timer and if that is true and the space bar is pressed shoot a bullet
        if self.shotTimer <= 0:
            pygame.mixer.Sound.play(enemyShot)
            pygame.mixer.music.stop()

            bullet_x_speed = 200*math.cos(self.rotation)
            bullet_y_speed = 200*math.sin(self.rotation)
            new_bullet = enemyBullet(self.enemyX,self.enemyY,bullet_x_speed,bullet_y_speed)
            self.enemy_bullet_list.append(new_bullet)
            self.shotTimer += 2

                #Sound for shooting?




    def draw(self,surf):

        surf.blit(self.rotImg, (self.enemyX - self.rotImg.get_width() / 2, self.enemyY - self.rotImg.get_height() / 2))
        #pygame.draw.circle(surf,(255,0,0),(int(self.enemyX),int(self.enemyY)),self.rad,1)
        for b in self.enemy_bullet_list:
            b.draw(surf)
class enemyBullet:
    def __init__(self,x,y,x_speed,y_speed):
        self.x = x
        self.y = y
        self.x_speed = x_speed
        self.y_speed = y_speed
    def update(self,dt):
        self.x += self.x_speed * dt
        self.y += self.y_speed * dt

    def draw(self, surf):


        pygame.draw.circle(surf,(255,0,0),(int(self.x),int(self.y)),5)